//
//  GridViewTemplatePresenter.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/18/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import Foundation
import RxSwift
import RxCocoa
import Action

protocol GridViewTemplateListener {
    func carouselTemplateDidGetErorr(_ error: SuperSpaManagementError)
    func carouselTemplateDidGetEmptyData()
    func carouselTemplateDidSelected(_ model: GridItemable)
    func carouselTemplateGotData()
}

protocol GridViewTemplateViewInterface: ViewInterface {
    var viewModels: BehaviorRelay<[ProductCarouselCellViewModel]> { get }
}

final class GridViewTemplatePresenter: GridViewTemplatePresenterInterface {

    // MARK: - Private properties -

    private lazy var getProductsAction = makeGetProductsAction()
    private let disposeBag = DisposeBag()
    
    private unowned let view: GridViewTemplateViewInterface
    private let interactor: GridViewTemplateInteractorInterface
    private let wireframe: GridViewTemplateWireframeInterface

    // MARK: - Lifecycle -

    init(view: GridViewTemplateViewInterface, interactor: GridViewTemplateInteractorInterface, wireframe: GridViewTemplateWireframeInterface) {
        self.view = view
        self.interactor = interactor
        self.wireframe = wireframe
        
        configurePresenter()
    }
}

// MARK: - Extensions -

extension GridViewTemplatePresenter {
    private func configurePresenter() {
        getProductsAction
            .elements
            .map {
                $0
                    .map { _ in ProductCarouselCellViewModel() }
            }
            .bind(to: view.viewModels)
            .disposed(by: disposeBag)
        
        getProductsAction.execute(.zero)
    }
}

extension GridViewTemplatePresenter {
    func makeGetProductsAction() -> Action<Int, [Product]> {
        return Action<Int, [Product]> { [unowned  self] categoryId in
            return interactor.getProducts(by: categoryId)
        }
    }
}
